VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cCamera"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

    'Last update: 2004-04-05
    'by fox@yhoko.com - http://fox.yhoko.com

'Types
    Private Position As D3DVECTOR
    
    Public Angle As Single
    Public Flatten As Single
    
    Private Up As D3DVECTOR

Public Function GetDistance(iPoint As D3DVECTOR) As Single
    'Return distance
    GetDistance = ((Position.x - iPoint.x) * (Position.x - iPoint.x) + (Position.Y - iPoint.Y) * (Position.Y - iPoint.Y) + (Position.Z - iPoint.Z) * (Position.Z - iPoint.Z)) ^ 0.5
End Function

Function GetZ() As Single
    GetZ = Position.Z
End Function

Function GetY() As Single
    GetY = Position.Y
End Function


Public Sub Move(iDistance As Single)
    'Move forward / backward
    Position.x = Position.x + (iDistance * Cos(-Angle))
    Position.Y = Position.Y + (-iDistance * Sin(-Angle))
End Sub

Public Sub Zoom(iDistance As Single)
    Dim TempX As Single
    Dim TempY As Single
    Dim TempZ As Single
    
    'Get zoom direction
    TempZ = Cos(-(Pi / 2 - Flatten))
    TempY = -Sin(-(Pi / 2 - Flatten))
    TempX = -TempY * Cos(-Angle)
    TempY = TempY * Sin(-Angle)
    
    'Zoom
    Position.x = Position.x + (TempX * iDistance)
    Position.Y = Position.Y + (TempY * iDistance)
    Position.Z = Position.Z + (TempZ * iDistance)
End Sub

Public Function GetProjection() As D3DMATRIX
    'Return projection matrix
    If ProjectionRH = False Then: D3DXMatrixLookAtLH GetProjection, Vec3(Position.x - Cos(Flatten) * Cos(Angle), Position.Y - Cos(Flatten) * Sin(Angle), Position.Z + Sin(Flatten)), Vec3(Position.x, Position.Y, Position.Z), Up
    If ProjectionRH = True Then: D3DXMatrixLookAtRH GetProjection, Vec3(Position.x - Cos(Flatten) * Cos(Angle), Position.Y - Cos(Flatten) * Sin(Angle), Position.Z + Sin(Flatten)), Vec3(Position.x, Position.Y, Position.Z), Up
End Function

Public Sub SetPosition(x As Single, Y As Single, Z As Single)
    With Position
        .x = x
        .Y = Y
        .Z = Z
    End With
End Sub

Public Sub AddPosition(x As Single, Y As Single, Z As Single)
    With Position
        .x = .x + x
        .Y = .Y + Y
        .Z = .Z + Z
    End With
End Sub

Public Sub Strafe(iDistance As Single)
    'Move sidewards
    Position.x = Position.x - (iDistance * Sin(-Angle))
    Position.Y = Position.Y - (iDistance * Cos(-Angle))
End Sub

Private Sub Class_Initialize()
    'Up vector
    Up = Vec3(0, 0, -1)
End Sub


