VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cDevice"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

    'Last update: 2004-04-05
    'by fox@yhoko.com - http://fox.yhoko.com

'Types
    Private Type tTexture
        FileName As String
        
        Surface As Direct3DTexture8
        
        ColorKey As Boolean
        KeyColor As Long
    End Type
    
    Private Type tMesh
        FileName As String
        
        Mesh As D3DXMesh
        MatCount As Long
        Mat() As D3DMATERIAL8
        Tex() As Long
    End Type

'Internal
    Public Device As Direct3DDevice8
    
    Private Caps As D3DCAPS8
    Private Parameters As D3DPRESENT_PARAMETERS
    Private DisplayMode As D3DDISPLAYMODE
    
    Public ResX As Long
    Public ResY As Long
    
    Public DepthBufferFormat As Long
    Public MultiSampleType As Long
    
    Private ProjectionMatrix As D3DMATRIX
    
    Private LastTexture() As Long
    Private LastLight As Long

'Textures
    Private TextureCount As Long
    Private Texture() As tTexture

'Frame counter
    Private FrameCount As Long
Public Sub AddLight(iLight As D3DLIGHT8)
    'Add and enable light
    LastLight = LastLight + 1
    Device.SetLight LastLight, iLight
    Device.LightEnable LastLight, 1
End Sub


Public Function BeginScene(iCamera As cCamera) As Boolean
On Error GoTo 1
    FunctionName = "cDevice.BeginScene"
    
    Dim A As Long
    
    'Check device state
    If Device.TestCooperativeLevel = D3DERR_DEVICENOTRESET Then
        Device.Reset Parameters: Exit Function
    End If
    
    With Device
        'Disable lights
        For A = 0 To LastLight: .LightEnable A, 0: Next
        LastLight = -1
        
        'Clear backbuffer
        .Clear 0, ByVal 0, D3DCLEAR_TARGET, D3DColorRGBA(0, 0, 0, 0), 1, 0
        .Clear 0, ByVal 0, D3DCLEAR_ZBUFFER, D3DColorRGBA(0, 0, 0, 0), 1, 0
        '.Clear 0, ByVal 0, D3DCLEAR_STENCIL, D3DColorRGBA(0, 0, 0, 0), 1, 1
        
        'Setup view matrix
        .SetTransform D3DTS_VIEW, iCamera.GetProjection
        
        'Begin the scene
        .BeginScene
    End With
    
    'Done
    BeginScene = True
    Exit Function

1  'Error
    MsgBox "Error in " & FunctionName & NL & NL & Err.Description
End Function

Private Function CheckMultiSampleType(iType As Long) As Boolean
    CheckMultiSampleType = (D3D.CheckDeviceMultiSampleType(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DisplayMode.Format, 1, iType) = D3D_OK)
End Function

Private Function CheckDepthBufferFormat(iFormat As Long) As Boolean
    CheckDepthBufferFormat = (D3D.CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, DisplayMode.Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, iFormat) = D3D_OK)
End Function

Public Sub EndScene()
On Error GoTo 1
    FunctionName = "cDevice.BeginScene"
    
    'End scene
    Device.EndScene
    UnsetTextures
    
    'Flip
    Device.Present ByVal 0, ByVal 0, 0, ByVal 0
    
    'Frame counter
    FrameCount = FrameCount + 1
    Exit Sub

1  'Error
    MsgBox "Error in " & FunctionName & NL & NL & Err.Description
End Sub

Public Function FindBest_MultiSampleType() As Long
    Dim Temp As Long
    
    'Get adapter info
    D3D.GetAdapterDisplayMode D3DADAPTER_DEFAULT, DisplayMode
    D3D.GetDeviceCaps D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, Caps
    
    'Find best multi sample type
    If CheckMultiSampleType(D3DMULTISAMPLE_8_SAMPLES) Then
        Temp = D3DMULTISAMPLE_8_SAMPLES
    ElseIf CheckMultiSampleType(D3DMULTISAMPLE_7_SAMPLES) Then
        Temp = D3DMULTISAMPLE_7_SAMPLES
    ElseIf CheckMultiSampleType(D3DMULTISAMPLE_6_SAMPLES) Then
        Temp = D3DMULTISAMPLE_6_SAMPLES
    ElseIf CheckMultiSampleType(D3DMULTISAMPLE_5_SAMPLES) Then
        Temp = D3DMULTISAMPLE_5_SAMPLES
    ElseIf CheckMultiSampleType(D3DMULTISAMPLE_4_SAMPLES) Then
        Temp = D3DMULTISAMPLE_4_SAMPLES
    ElseIf CheckMultiSampleType(D3DMULTISAMPLE_3_SAMPLES) Then
        Temp = D3DMULTISAMPLE_3_SAMPLES
    ElseIf CheckMultiSampleType(D3DMULTISAMPLE_2_SAMPLES) Then
        Temp = D3DMULTISAMPLE_2_SAMPLES
    Else 'No multisampling available
        Temp = D3DMULTISAMPLE_NONE
    End If
    
    'Return result
    FindBest_MultiSampleType = Temp
End Function

Public Function FindBest_DepthBufferFormat() As Long
    Dim Temp As Long
    
    'Get adapter info
    D3D.GetAdapterDisplayMode D3DADAPTER_DEFAULT, DisplayMode
    D3D.GetDeviceCaps D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, Caps
    
    'Find best depth buffer
    If CheckDepthBufferFormat(D3DFMT_D32) Then
        Temp = D3DFMT_D32
    ElseIf CheckDepthBufferFormat(D3DFMT_D24X4S4) Then
        Temp = D3DFMT_D24X4S4
    ElseIf CheckDepthBufferFormat(D3DFMT_D24S8) Then
        Temp = D3DFMT_D24S8
    ElseIf CheckDepthBufferFormat(D3DFMT_D24X8) Then
        Temp = D3DFMT_D24X8
    ElseIf CheckDepthBufferFormat(D3DFMT_D15S1) Then
        Temp = D3DFMT_D15S1
    ElseIf CheckDepthBufferFormat(D3DFMT_D16) Then
        Temp = D3DFMT_D16
    End If
    
    'Return result
    FindBest_DepthBufferFormat = Temp
End Function
Public Function GetFPS() As Single
    Static LastCheck As Long
    
    'Return FPS
    GetFPS = CSng(FrameCount) / (CSng(GetTickCount - LastCheck) / 1000)
    
    'Reset counter
    LastCheck = GetTickCount
    FrameCount = 0
End Function

Public Function TextureColorKey(Index As Long) As Boolean
    If Index < 0 Then: Exit Function
    
    TextureColorKey = Texture(Index).ColorKey
End Function

Public Sub UnsetTextures()
    Dim A As Long
    
    For A = 0 To 1
        'Release textures
        Device.SetTexture A, Nothing
        LastTexture(A) = -1
    Next
End Sub

Public Function LoadTexture(iFileName As String, Optional iColorKey As Long = -1) As Long
On Error GoTo 1
    FunctionName = "cDevice.LoadTexture"

    Dim A As Long
    
    'Error checking
    If Not Exists(iFileName) Then: Exit Function
    
    'Find existing
    For A = 0 To TextureCount
        If StrComp(Texture(A).FileName, iFileName, vbTextCompare) = 0 Then
            'Return index
            LoadTexture = A
            
            Exit Function
        End If
    Next
    
    'Create new
    TextureCount = TextureCount + 1
    ReDim Preserve Texture(TextureCount)
    
    With Texture(TextureCount)
        'Setup texture
        .FileName = iFileName
        
        If iColorKey > -1 Then
            .ColorKey = True 'Color key
            .KeyColor = iColorKey
            
            'Load with color key // &HFFFF00FF = magenta
            Set .Surface = D3DX.CreateTextureFromFileEx(Device, .FileName, D3DX_DEFAULT, D3DX_DEFAULT, 1, 0, D3DFMT_UNKNOWN, D3DPOOL_DEFAULT, D3DX_FILTER_LINEAR, D3DX_FILTER_LINEAR, .KeyColor, ByVal 0, ByVal 0)

        Else
            .ColorKey = (InStr(1, iFileName, ".png", vbTextCompare) > 0) 'Colorkey
            
            'Load new texture
            Set .Surface = D3DX.CreateTextureFromFile(Device, .FileName)
        End If
    End With
    
    'Return index
    LoadTexture = TextureCount
    Exit Function

1  'Error
    LoadTexture = -1
    MsgBox "Error in " & FunctionName & NL & NL & Err.Description
End Function

Public Sub Release()
On Error GoTo 1
    FunctionName = "cDevice.Release"
    
    Dim A As Long
    
    'Release textures
    For A = 0 To TextureCount: Set Texture(A).Surface = Nothing: Next
    
    'Release objects
    Set Device = Nothing
    Exit Sub

1  'Error
    MsgBox "Error in " & FunctionName & NL & NL & Err.Description
End Sub

Public Function Initialize(iHandle As Long, iW As Long, iH As Long, iDepthBufferFormat As Long, iMultiSampleType As Long) As Boolean
On Error GoTo 1
    FunctionName = "cDevice.Initialize"

    'Get adapter info
    D3D.GetAdapterDisplayMode D3DADAPTER_DEFAULT, DisplayMode
    D3D.GetDeviceCaps D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, Caps
    
    'Get resolution
    ResX = iW
    ResY = iH
    
    'Check depth buffer format
    If iDepthBufferFormat = 0 Then: GoTo 1
    
    With Parameters
        'Setup
        '.SwapEffect = D3DSWAPEFFECT_DISCARD 'Necessary for multisampling; otherwise: D3DSWAPEFFECT_COPY_VSYNC
        .SwapEffect = D3DSWAPEFFECT_COPY_VSYNC
        
        .BackBufferFormat = DisplayMode.Format
        .BackBufferCount = 1
        .BackBufferWidth = ResX
        .BackBufferHeight = ResY
        
        .EnableAutoDepthStencil = 1
        .AutoDepthStencilFormat = iDepthBufferFormat
        .MultiSampleType = iMultiSampleType
        
        .Windowed = 1
        .hDeviceWindow = iHandle
    End With
    
    'Create device
    Set Device = D3D.CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, iHandle, D3DCREATE_SOFTWARE_VERTEXPROCESSING, Parameters)
    If Device Is Nothing Then: GoTo 1
    
    With Device
        'Rendering
        .SetRenderState D3DRS_FILLMODE, D3DFILL_SOLID
        .SetRenderState D3DRS_SHADEMODE, D3DSHADE_GOURAUD
        
        'Lighting
        .SetRenderState D3DRS_LIGHTING, 0
        .SetRenderState D3DRS_SPECULARENABLE, 0
        
        'Optimizations
        .SetRenderState D3DRS_ZENABLE, D3DZB_TRUE
        .SetRenderState D3DRS_CULLMODE, D3DCULL_CCW
        .SetRenderState D3DRS_CLIPPING, 1
        
        'Anti alias
        If MultiSampleType = D3DMULTISAMPLE_NONE Then
            .SetRenderState D3DRS_MULTISAMPLE_ANTIALIAS, 0
        Else
            .SetRenderState D3DRS_MULTISAMPLE_ANTIALIAS, 1
        End If
        
        'Alpha blending
        .SetRenderState D3DRS_ALPHABLENDENABLE, 0
        .SetRenderState D3DRS_ALPHATESTENABLE, 0
        
        If (Caps.AlphaCmpCaps And D3DPCMPCAPS_GREATEREQUAL) > 0 Then
            'Alpha testing
            .SetRenderState D3DRS_ALPHAREF, &H8&
            .SetRenderState D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL
        End If
        
        'Setup stage 0 filtering
        .SetTextureStageState 0, D3DTSS_MINFILTER, D3DTEXF_LINEAR
        .SetTextureStageState 0, D3DTSS_MAGFILTER, D3DTEXF_LINEAR
        
        'Setup stage 1 filtering
        .SetTextureStageState 1, D3DTSS_MINFILTER, D3DTEXF_LINEAR
        .SetTextureStageState 1, D3DTSS_MAGFILTER, D3DTEXF_LINEAR
        
        'Setup projection
        D3DXMatrixPerspectiveFovLH ProjectionMatrix, (Pi * 0.25), (ResY / ResX), 0.1, 800
        .SetTransform D3DTS_PROJECTION, ProjectionMatrix
    End With
    
    'Reset stages
    UnsetTextures
    
    'Done
    Initialize = True
    Exit Function
    
1  'Error
    MsgBox "Error in " & FunctionName & NL & NL & Err.Description
    LastError = D3DX.GetErrorString(Err.Number)
    
    Me.Release
End Function

Public Sub SetTexture(iStage As Long, iTexture As Long)
On Error GoTo 1
    FunctionName = "cDevice.SetTexture"
    
    If LastTexture(iStage) = iTexture Then: Exit Sub
    
    If iTexture < 0 Then: Exit Sub
    If iTexture > UBound(Texture) Then: Exit Sub
    
    'Set new texture
    Device.SetTexture iStage, Texture(iTexture).Surface
    LastTexture(iStage) = iTexture
    Exit Sub

1  'Error
    MsgBox "Error in " & FunctionName & NL & NL & Err.Description
End Sub

Public Sub SetupRenderer(iAlphaMode As Long, iBlendMode As Long, iColorVertex As Boolean)
On Error GoTo 1
    FunctionName = "cDevice.SetupRenderer"

    Static AlphaMode As Long
    Static BlendMode As Long
    Static ColorVertex As Boolean
    
    With Device
        'Alpha mode
        If Not AlphaMode = iAlphaMode Then
            AlphaMode = iAlphaMode
            
            Select Case AlphaMode
            Case 0 'None
                .SetTextureStageState 0, D3DTSS_ALPHAOP, D3DTOP_DISABLE
                
                .SetRenderState D3DRS_ALPHABLENDENABLE, 0
                .SetRenderState D3DRS_ALPHATESTENABLE, 0
                
'                .SetRenderState D3DRS_CULLMODE, D3DCULL_CCW
'                .SetRenderState D3DRS_ZFUNC, D3DCMP_LESSEQUAL
            
            Case 1 'From texture alpha
                .SetTextureStageState 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE
                .SetTextureStageState 0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1
                
                .SetRenderState D3DRS_ALPHABLENDENABLE, 1
                .SetRenderState D3DRS_ALPHATESTENABLE, 1
                
'                .SetRenderState D3DRS_CULLMODE, D3DCULL_NONE
'                .SetRenderState D3DRS_ZFUNC, D3DCMP_ALWAYS
            
            Case 2 'From texture factor
                .SetTextureStageState 0, D3DTSS_ALPHAARG1, D3DTA_TFACTOR
                .SetTextureStageState 0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1
                
                .SetRenderState D3DRS_ALPHABLENDENABLE, 1
                .SetRenderState D3DRS_ALPHATESTENABLE, 1
                
'                .SetRenderState D3DRS_CULLMODE, D3DCULL_NONE
'                .SetRenderState D3DRS_ZFUNC, D3DCMP_ALWAYS
            End Select
        End If
        
        'Blend mode
        If Not BlendMode = iBlendMode Then
            BlendMode = iBlendMode
            
            Select Case BlendMode
            Case 0 'Default
                .SetRenderState D3DRS_SRCBLEND, D3DBLEND_ONE
                .SetRenderState D3DRS_DESTBLEND, D3DBLEND_ZERO
            
            Case 1 'Transparent
                .SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
                .SetRenderState D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA
            
            Case 2 'Blend 1-1
                .SetRenderState D3DRS_SRCBLEND, D3DBLEND_ONE
                .SetRenderState D3DRS_DESTBLEND, D3DBLEND_ONE
            End Select
        End If
        
        'Color vertex
        If Not ColorVertex = iColorVertex Then
            ColorVertex = iColorVertex
            
            .SetRenderState D3DRS_COLORVERTEX, IIf(ColorVertex, 1, 0)
        End If
    End With
    Exit Sub

1  'Error
    MsgBox "Error in " & FunctionName & NL & NL & Err.Description
End Sub

Private Sub Class_Initialize()
    'Counters
    TextureCount = -1
    
    'Prepare for 8 texture stages ^^
    ReDim LastTexture(7)
End Sub


