VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cValues"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

    'Last update: 2004-02-27
    'by fox@yhoko.com - http://fox.yhoko.com

'Types
    Private Type tValue
        'System
        Name As String
        
        'Contained value
        IsNumber As Boolean
        Value As String
    End Type
    
    'Internal
    Private FileName As String

'Variables
    Private nValueCount As Long
    Private nValue() As tValue

Private Function IsNumber(iValue As Variant) As Boolean
    Dim A As Long
    Dim Numbers
    
    'Valid chars
    Numbers = "0123456789."
    If Len(iValue) = 0 Then: Exit Function
    If iValue Like "*.*.*" Then: Exit Function
    
    'Check each char
    For A = 0 To Len(iValue)
        If InStr(1, Numbers, Mid(iValue, A, A)) < 1 Then: Exit Function
    Next
    
    'Done
    IsNumber = True
End Function
Public Sub Reset()
    'Reset memory
    nValueCount = -1
    Erase nValue
End Sub

Public Property Get Value(iName As String) As Variant
On Error Resume Next

    Dim A As Long
    
    If Len(iName) < 1 Then: Exit Property
    
    For A = 0 To nValueCount
        If StrComp(nValue(A).Name, iName, vbTextCompare) = 0 Then
            'Return value
            If nValue(A).IsNumber Then
                Value = CLng(nValue(A).Value)
            Else
                Value = CStr(nValue(A).Value)
            End If
            
            Exit For
        End If
    Next
End Property

Public Sub SetDefault(iName As String, iValue As Variant)
On Error Resume Next

    Dim A As Long
    
    If Len(iName) < 1 Then: Exit Sub
    
    For A = 0 To nValueCount
        'Value found
        If StrComp(nValue(A).Name, iName, vbTextCompare) = 0 Then: Exit Sub
    Next
    
    'Add value
    Value(iName) = iValue
End Sub
Public Property Let Value(iName As String, iValue As Variant)
On Error Resume Next
    
    Dim A As Long
    
    If Len(iName) < 1 Then: Exit Property
    
    For A = 0 To nValueCount
        'Find existing value
        If StrComp(nValue(A).Name, iName, vbTextCompare) = 0 Then: Exit For
    Next
    
    If Len(iValue) < 1 Then
        'Delete value
        If A <= nValueCount Then
            'Release memory
            nValue(A) = nValue(nValueCount)
            nValueCount = nValueCount - 1
            ReDim Preserve nValue(nValueCount)
        End If
        
    Else
        If A > nValueCount Then
            'Allocate memory
            nValueCount = nValueCount + 1
            ReDim Preserve nValue(nValueCount)
            
            'Set name
            nValue(A).Name = iName
        End If
        
        'Set value
        nValue(A).Value = CStr(iValue)
        nValue(A).IsNumber = IsNumber(iValue)
    End If
End Property

Public Function SaveData(Optional iFileName As String = "") As Boolean
On Error GoTo 1

    Dim FileNumber As Integer
    
    'Open file
    If iFileName = "" Then: iFileName = FileName
    FileNumber = OpenFile(iFileName, True, True)
        If FileNumber < 1 Then: Exit Function
        
        SaveData = WriteData(FileNumber)
    Close FileNumber
    
    'Success
    SaveData = True
    Exit Function

1  'Error
    Close FileNumber
End Function

Public Function WriteData(iFileNumber As Integer) As Boolean
On Error GoTo 1

    'Write data
    Put iFileNumber, , nValueCount
    If nValueCount > -1 Then: Put iFileNumber, , nValue
   
    'Success
    WriteData = True
    Exit Function
    
1  'Error

End Function

Public Function LoadData(iFileName As String) As Boolean
On Error GoTo 1
    
    Dim FileNumber As Integer
    
    'Open file
    FileName = iFileName
    FileNumber = OpenFile(iFileName, True, False)
        If FileNumber < 1 Then: Exit Function
        
        LoadData = ReadData(FileNumber)
    Close FileNumber
    
    'Success
    LoadData = True
    Exit Function

1  'Error
    Close FileNumber
End Function

Public Function ReadData(iFileNumber As Integer) As Boolean
On Error GoTo 1

    'Read data
    Get iFileNumber, , nValueCount
    If nValueCount > -1 Then
        ReDim nValue(nValueCount)
        Get iFileNumber, , nValue
    End If
    
    'Success
    ReadData = True
    Exit Function

1  'Error

End Function
Private Sub Class_Initialize()
    'Initialize
    Reset
End Sub

Private Sub Class_Terminate()
    'Release values
    Reset
End Sub
