VERSION 5.00
Begin VB.Form frmMatrix 
   BackColor       =   &H00000000&
   BorderStyle     =   0  'Kein
   Caption         =   "The Matrix"
   ClientHeight    =   6930
   ClientLeft      =   0
   ClientTop       =   -105
   ClientWidth     =   8430
   Icon            =   "frmMatrix.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MouseIcon       =   "frmMatrix.frx":0CFA
   MousePointer    =   99  'Benutzerdefiniert
   ScaleHeight     =   462
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   562
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.Timer Timer1 
      Interval        =   10
      Left            =   0
      Top             =   0
   End
End
Attribute VB_Name = "frmMatrix"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Consts
    Private Const cVertexFormat = (D3DFVF_XYZ Or D3DFVF_TEX1)
    Private Const cVertexSize As Long = 20
    
    Private Const cTexFactor As Single = 1 / 16

'Types
    Private Type tVertex
        'Position
        x As Single
        Y As Single
        Z As Single
        
        'Texture coords
        u As Single
        v As Single
    End Type
    
    Private Type tRenderQueue
        Char As tPos2D
        Position As D3DVECTOR
        Color As D3DCOLORVALUE
    End Type

'Scene
    Dim Camera As New cCamera
    
    Dim TexLetters As Long
    
    Dim RenderQueueCount As Long
    Dim RenderQueue() As tRenderQueue

'Dynamical
    Dim ViewPort As D3DVIEWPORT8
    Dim ViewMatrix As D3DMATRIX
    Dim ProjectionMatrix As D3DMATRIX
    
    Dim TempMatrix As D3DMATRIX
    Dim WorldMatrix As D3DMATRIX
    
    Dim FlatMesh() As tVertex
    Dim FlatMeshBuffer As Direct3DVertexBuffer8
Private Sub RenderChar(iCharX As Long, iCharY As Long, iX As Single, iY As Single, iZ As Single, iColorR As Single, iColorG As Single, iColorB As Single)
    'Allocate memory
    RenderQueueCount = RenderQueueCount + 1
    ReDim Preserve RenderQueue(RenderQueueCount)
    
    'Setup char
    With RenderQueue(RenderQueueCount)
        .Char.x = iCharX
        .Char.Y = iCharY
        
        .Position.x = iX
        .Position.Y = iY
        .Position.Z = iZ
        
        .Color.R = iColorR
        .Color.G = iColorG
        .Color.B = iColorB
    End With
End Sub

Private Sub DoRenderQueue()
On Error Resume Next

    Dim A As Long
    
    Dim TexX As Single
    Dim TexY As Single
    
    For A = 1 To RenderQueueCount
        With RenderQueue(A)
            'Get letter position
            TexX = CSng(.Char.x) * cTexFactor
            TexY = CSng(.Char.Y) * cTexFactor
            
            'Setup tile
            With FlatMesh(0): .u = TexX: .v = TexY: End With
            With FlatMesh(1): .u = TexX + cTexFactor: .v = TexY + cTexFactor: End With
            With FlatMesh(2): .u = TexX + cTexFactor: .v = TexY: End With
            
            With FlatMesh(3): .u = TexX: .v = TexY: End With
            With FlatMesh(4): .u = TexX: .v = TexY + cTexFactor: End With
            With FlatMesh(5): .u = TexX + cTexFactor: .v = TexY + cTexFactor: End With
            
            'Fill VBuffer
            D3DVertexBuffer8SetData FlatMeshBuffer, 0, cVertexSize * 6, 0, FlatMesh(0)
            
            'Setup fading
            Device.Device.SetRenderState D3DRS_AMBIENT, D3DColorMake(.Color.R, .Color.G, .Color.B, 1)
            
            'Setup position
            D3DXMatrixTranslation WorldMatrix, .Position.x, .Position.Y, .Position.Z
        End With
        
        With Device.Device
            'Render stream
            .SetTransform D3DTS_WORLD, WorldMatrix
            .SetStreamSource 0, FlatMeshBuffer, cVertexSize
            .DrawPrimitive D3DPT_TRIANGLELIST, 0, 2
        End With
    Next
    
    RenderQueueCount = 0
End Sub
Private Sub Form_Load()
On Error GoTo 1
    FunctionName = "frmMain.Unload"

    'Switch to fullscreen
    Active = True
    ProjectionRH = True
    
    Me.Move 0, 0, Screen.Width, Screen.Height
    Me.Show
    
    'Init device
    Set Device = New cDevice
    If Not Device.Initialize(Me.hwnd, Me.ScaleWidth, Me.ScaleHeight, D3DFMT_D16, D3DMULTISAMPLE_NONE) Then
        MsgBox "DirectX error: " & LastError, vbCritical, "Matrix": End
    End If
    
    'Setup
    With Device.Device
        .SetRenderState D3DRS_CLIPPING, 1
        .SetRenderState D3DRS_CULLMODE, D3DCULL_CW
        
        .SetRenderState D3DRS_LIGHTING, 1
        .SetRenderState D3DRS_ZBIAS, 1
    End With
    Device.SetupRenderer 2, 2, False
    
    'Setup cameras
    Set Camera = New cCamera
    With Camera
        .SetPosition 0, 0, 0
        .Angle = (Pi2 / 360) * 270
        .Flatten = (Pi2 / 360) * 0
    End With
    
    'Create buffer
    ReDim FlatMesh(6 - 1)
    Set FlatMeshBuffer = Device.Device.CreateVertexBuffer(cVertexSize * 6, 0, cVertexFormat, D3DPOOL_DEFAULT)
    
    'Setup buffer
    With FlatMesh(0): .x = -0.5: .Z = -0.5: End With
    With FlatMesh(1): .x = 0.5: .Z = 0.5: End With
    With FlatMesh(2): .x = 0.5: .Z = -0.5: End With
    
    With FlatMesh(3): .x = -0.5: .Z = -0.5: End With
    With FlatMesh(4): .x = -0.5: .Z = 0.5: End With
    With FlatMesh(5): .x = 0.5: .Z = 0.5: End With
    
    'Textures
    If Not Exists(Path & "letters.png") Then
        MsgBox "Texture file not found! Make sure all files were extracted to the same directory.", vbCritical, "Error loading textures": Unload Me
    End If
    TexLetters = Device.LoadTexture(Path & "letters.png", -1)
    Exit Sub

1  'Error
    MsgBox "Error in " & FunctionName & NL & NL & Err.Description
End Sub

Private Sub RenderLetters()
On Error Resume Next

    Dim A As Long
    Dim B As Long
    
    Static C As Long
    Static Chars() As D3DVECTOR
    Static CharsTex() As tPos2D
    Dim Fade As Single
    
    If C = 0 Then
        C = 1000
        ReDim Chars(C)
        ReDim CharsTex(C)
        For A = 0 To C
            GoSub ResetChar
            Chars(A) = Vec3(50 * Rnd - 25, 100 * Rnd, 50 * Rnd - 25)
        Next
    End If
    
    Dim Material As D3DMATERIAL8
    
    'Setup renderer
    With Device
        .Device.SetVertexShader cVertexFormat
        .Device.SetRenderState D3DRS_AMBIENT, D3DColorMake(1, 1, 1, 1)
    End With
    
    'Setup material
    Material.diffuse = RGBA(1, 1, 1, 0)
    Material.Ambient = Material.diffuse
    Device.Device.SetMaterial Material
    
    For A = 0 To C
        Fade = 1 - Chars(A).Y * 0.01
        RenderChar CharsTex(A).x, CharsTex(A).Y, Chars(A).x, Chars(A).Y, Chars(A).Z, Fade * 0.2, Fade, Fade * 0
        
        If 1000 * Rnd < 5 Then
            CharsTex(A).x = 15 * Rnd
            CharsTex(A).Y = 15 * Rnd
        End If
        
        Chars(A).Y = Chars(A).Y - 0.2
        If Chars(A).Y < 0 Then: GoSub ResetChar
    Next
    
    'Render it
    Device.SetTexture 0, TexLetters
    DoRenderQueue
    Device.SetTexture 0, 0

'Subs
ResetChar:
    Chars(A) = Vec3(50 * Rnd - 25, 100, 50 * Rnd - 25)
    CharsTex(A).x = 15 * Rnd
    CharsTex(A).Y = 15 * Rnd
Return
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
Active = 0
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, Y As Single)
    Camera.SetPosition (x - 512) / 100, 0, (Y - 384) / 100
End Sub

Private Sub Form_Unload(Cancel As Integer)
On Error GoTo 1
    FunctionName = "frmMain.Unload"
    
    Device.Release
    
    Set Device = Nothing
    Set Camera = Nothing
    
    'Release memory
    DoEvents
    mCore.Release
    Exit Sub

1  'Error
    MsgBox "Error in " & FunctionName & NL & NL & Err.Description
End Sub

Private Sub Timer1_Timer()
On Error Resume Next

    With Device
        .BeginScene Camera
        
        RenderLetters
        
        .EndScene
    End With
    
    If Not Active Then: Unload Me
End Sub


