Attribute VB_Name = "mCore"
Option Explicit

    'Last update: 2004-04-05
    'by fox@yhoko.com - http://fox.yhoko.com

'Consts
    Public Const NL As String = vbNewLine
    
    Public Const Pi As Single = 3.141593
    Public Const Pi2 As Single = 6.283185

'Types
    Public Type tPos2D
        x As Long
        Y As Long
    End Type

'Declares
    Public Declare Function GetTickCount Lib "kernel32" () As Long
    Public Declare Sub Sleep Lib "kernel32" (ByVal Interval As Long)
    
    Public Declare Function SetThreadPriority Lib "kernel32" (ByVal iThread As Long, ByVal iPriority As Long) As Long
    Public Declare Function SetPriorityClass Lib "kernel32" (ByVal iProcess As Long, ByVal iPriorityClass As Long) As Long
    
    Public Declare Function GetCurrentThread Lib "kernel32" () As Long
    Public Declare Function GetCurrentProcess Lib "kernel32" () As Long

'    Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
'    Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

    Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
    Public Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long
    Public Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long

'Variables
    Private LastParent As Long

'Variables
    Public VersionLong As Long
    Public VersionString As String
    
    Public Device As cDevice
    Public Settings As cValues
    
    Public LastError As String
    Public FunctionName As String
    
    Public Active As Boolean
    Public Tick As Long
    
    Public ProjectionRH As Boolean

Public Sub StayBehind(iActivate As Boolean)
    If iActivate Then
        'Set behind
        If LastParent = 0 Then: LastParent = SetParent(frmMain.hwnd, GetWindow(GetWindow(FindWindow("Progman", "Program Manager"), 5), 5))
    
    Else
        If LastParent > 0 Then
            'Set normal
            Call SetParent(frmMain.hwnd, LastParent)
            LastParent = 0
        End If
    End If
End Sub
Public Function DebugMode() As Boolean
    Static Counter As Variant
    
    'Check counter
    If IsEmpty(Counter) Then
        'First run
        Counter = 1
        Debug.Assert DebugMode() Or True
        Counter = Counter - 1
    
    ElseIf Counter = 1 Then
        'Recursive call
        Counter = 0
    End If
    
    'Return
    DebugMode = Counter
End Function


Public Sub Initialize()
On Error GoTo 1
    FunctionName = "mCore.Initialize"

    'Random seed
    Tick = GetTickCount
    VBA.Randomize Tick
    
    'Initialize all
    mFileSystem.Initialize
    
    Set Settings = New cValues
    Settings.LoadData Path & "matrix.ini"
    
    mDXGraphics.Initialize
    Exit Sub

1  'Error
    MsgBox "Error in " & FunctionName & NL & NL & Err.Description
End Sub

Public Sub Release()
    'Window proc
    mDXGraphics.Release
    
    Settings.SaveData
    Set Settings = Nothing
    
    End
End Sub

Public Sub OpenURL(iURL As String)
On Error Resume Next

    Dim Temp As Object
    
    'Create instance
    Set Temp = CreateObject("InternetExplorer.Application")
    
    'Open URL
    Temp.Navigate2 iURL
    Temp.Visible = True
End Sub


Public Sub Main()
On Error GoTo 1
    FunctionName = "mCore.Main"
    
    If App.PrevInstance Then: End
    If Command Like "/p*" Then: End
    If Command Like "/c*" Then
        MsgBox "To configure don't move your mouse and press right-click while running.", vbInformation, "Matrix"
        End
    End If
    
    'Set priority
    SetThreadPriority GetCurrentThread, -2
    SetPriorityClass GetCurrentProcess, -15
    
    'System
    VersionLong = (App.Major * 10000) + (App.Minor * 100) + (App.Revision)
    VersionString = CStr(App.Major) & "." & CStr(App.Minor) & "." & CStr(App.Revision)
    
    'Initialize
    Initialize
    
    'Show
    frmMain.Show
'    frmMatrix.Show
    Exit Sub

1  'Error
    MsgBox "Error in " & FunctionName & NL & NL & Err.Description
End Sub
