Attribute VB_Name = "mDXGraphics"
Option Explicit

    'Last update: 2004-04-05
    'by fox@yhoko.com - http://fox.yhoko.com

'Const
    Public Const cKeySize_Vector As Long = 20
    Public Const cKeySize_Rotation As Long = 24
    Public Const cKeySize_Matrix As Long = 72
    Public Const cMatrixSize As Long = 64

'Types
    Public Type tKeyHeader
        Type As Long
        Count As Long
    End Type
    
    Public Type tAnimationOptions
        Repeat As Long
        Quality As Long
    End Type
    
    Public Type tVectorKey
        Time As Long
        Floats As Long
        
        Vector As D3DVECTOR
    End Type
    
    Public Type tRotationKey
        Time As Long
        Floats As Long
        
        Quat As D3DQUATERNION
    End Type
    
    Public Type tMatrixKey
        Time As Long
        Floats As Long
        
        Matrix As D3DMATRIX
    End Type
    
    Public Type tInt3D
        X As Integer
        Y As Integer
        z As Integer
    End Type
    
    Public Type tByte3D
        X As Byte
        Y As Byte
        z As Byte
    End Type

'Global
    Public DirectX As DirectX8

    Public IdentityMatrix As D3DMATRIX

'Internal
    Public D3D As Direct3D8
    Public D3DX As D3DX8
Public Function Initialize() As Boolean
On Error GoTo 1
    FunctionName = "mDXGraphics.Initialize"
    
    'Initialize
    Set DirectX = New DirectX8
    Set D3DX = New D3DX8
    
    'Setup
    Set D3D = DirectX.Direct3DCreate
    If D3D Is Nothing Then: Exit Function
    
    'Setup matrix
    D3DXMatrixIdentity IdentityMatrix
    
    'Done
    Initialize = True
    Exit Function

1  'Error
    MsgBox "Error in " & FunctionName & NL & NL & Err.Description
End Function

Public Function RGBA(R As Single, G As Single, B As Single, A As Single) As D3DCOLORVALUE
    'Return D3D color
    With RGBA: .R = R: .G = G: .B = B: .A = A: End With
End Function

Public Function Vec3(X As Single, Y As Single, z As Single) As D3DVECTOR
    'Return vector
    With Vec3: .X = X: .Y = Y: .z = z: End With
End Function

Public Sub Release()
On Error GoTo 1
    FunctionName = "mDXGraphics.Release"
    
    'Release objects
    Set D3DX = Nothing
    Set D3D = Nothing
    Set DirectX = Nothing
    Exit Sub

1  'Error
    MsgBox "Error in " & FunctionName & NL & NL & Err.Description
End Sub
