Attribute VB_Name = "mFileSystem"
Option Explicit

    'Last update: 2004-04-05
    'by fox@yhoko.com - http://fox.yhoko.com

'Declares
    Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal iBuffer As String, ByVal iSize As Long) As Long
    Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal iBuffer As String, ByVal iSize As Long) As Long

'Variables
    Public Path As String
Public Sub ScanDirectory(iPath As String, iFolders() As String, iFiles() As String)
On Error Resume Next

    Dim Temp As String
    Dim Path As String
    Dim Attrib As VbFileAttribute
    
    Dim FolderCount As Long
    Dim FileCount As Long
    
    'Setup
    FolderCount = -1
    FileCount = -1
    Path = iPath & IIf(Right(iPath, 1) = "\", "", "\")
    
    'Scan folder
    Temp = Dir(Path, vbArchive Or vbDirectory Or vbHidden Or vbReadOnly Or vbSystem)
    While Len(Temp) > 0
        If Not (Temp = "." Or Temp = "..") Then
            Attrib = GetAttr(Path & Temp)
            
            If (Attrib And vbDirectory) = vbDirectory Then
                'Add folder
                FolderCount = FolderCount + 1
                ReDim Preserve iFolders(FolderCount)
                iFolders(FolderCount) = Temp
            Else
                'Add file
                FileCount = FileCount + 1
                ReDim Preserve iFiles(FileCount)
                iFiles(FileCount) = Temp
            End If
        End If
        
        'Get next item
        Temp = Dir
    Wend
End Sub
Public Sub WriteString(iFileNumber As Integer, iString As String)
    'Write string data
    Put iFileNumber, , CLng(Len(iString))
    Put iFileNumber, , CStr(iString)
End Sub

Public Function ReadFileB(iFileName As String, ByRef iData() As Byte) As Boolean
On Error GoTo 1

    Dim FileNumber As Integer
    
    'Open file
    FileNumber = OpenFile(iFileName, True, False)
    If FileNumber < 1 Then: Exit Function
        'Allocate memory
        ReDim Preserve iData(LOF(FileNumber) - 1)
        
        'Read data
        Get FileNumber, , iData
    Close FileNumber
    
    'Return
    ReadFileB = True
    Exit Function

1  'Error
    Close FileNumber
End Function

Public Sub ReadString(iFileNumber As Integer, iString As String)
    Dim Temp As Long
    
    'Read string data
    Get iFileNumber, , Temp
    iString = Space(Temp)
    Get iFileNumber, , iString
End Sub

Public Function OpenFile(iFileName As String, iBinary As Boolean, iWrite As Boolean) As Integer
On Error GoTo 1

    Dim FileNumber As Integer
    
    If iWrite Then
        'Delete existing file
        If Exists(iFileName) Then: DeleteFile iFileName
        If Exists(iFileName) Then: Exit Function
        
    Else
        'Check filename
        If Not Exists(iFileName) Then: Exit Function
    End If
    
    'Get filenumber
    FileNumber = FreeFile
    
    If iBinary Then
        'Open binary file
        Open iFileName For Binary As FileNumber
        
    Else
        'Open ASCII file
        If iWrite Then
            Open iFileName For Output Shared As FileNumber
        Else
            Open iFileName For Input As FileNumber
        End If
    End If
    
    'Return filenumber
    OpenFile = FileNumber
    Exit Function
    
1  'Error
    Close FileNumber
End Function

Public Function WriteFileB(iFileName As String, ByRef iData() As Byte) As Boolean
On Error GoTo 1

    Dim FileNumber As Integer
    
    'Open file
    FileNumber = OpenFile(iFileName, True, True)
    If FileNumber < 1 Then: Exit Function
        'Write data
        Put FileNumber, , iData
    Close FileNumber
    
    'Return
    WriteFileB = True
    Exit Function

1  'Error
    Close FileNumber
End Function
Public Function GetSysDir() As String
On Error GoTo 1

    Dim Temp As String
    Dim Length As Long
    
    'Crate buffer
    Length = 255
    Temp = Space(Length)
    
    'Get windows directory
    Length = GetSystemDirectory(Temp, Length)
    Temp = Left(Temp, Length)
    
    'Return directory
    GetSysDir = Temp & IIf(Right(Temp, 1) = "\", "", "\")
    Exit Function
    
1  'Error
End Function

Public Function GetWinDir() As String
On Error GoTo 1

    Dim Temp As String
    Dim Length As Long
    
    'Crate buffer
    Length = 255
    Temp = Space(Length)
    
    'Get windows directory
    Length = GetWindowsDirectory(Temp, Length)
    Temp = Left(Temp, Length)
    
    'Return directory
    GetWinDir = Temp & IIf(Right(Temp, 1) = "\", "", "\")
    Exit Function
    
1  'Error
End Function

Private Function CreatePath(iPath As String) As String
On Error GoTo 1

    Dim A As Long
    Dim Directory() As String
    Dim DirectoryCount As Long
    Dim Temp As String
    
    'Variables
    Directory = Split(iPath, "\")
    DirectoryCount = UBound(Directory)
    Temp = Directory(0) & "\"
    
    'Check each parent directory
    For A = 1 To DirectoryCount
        If Len(Directory(A)) > 0 Then
            Temp = Temp & Directory(A) & "\"
            
            If Len(Dir(Temp, vbDirectory)) = 0 Then: MkDir Temp
        End If
    Next
    
    'Check path
    If Len(Dir(Temp, vbDirectory)) = 0 Then: Temp = iPath
    
    'Return Result
    CreatePath = Temp
    Exit Function
    
1  'Error
    CreatePath = iPath
End Function

Public Function DeleteFile(iFileName As String) As Boolean
On Error GoTo 1

    If Exists(iFileName) Then
        'Setup file
        SetAttr iFileName, vbNormal
        
        'Delete
        Kill iFileName
    End If
    
    'Return
    DeleteFile = True
    Exit Function

1  'Error

End Function

Public Function GetPath(iPath As String, Optional iCreate As Boolean = False) As String
    Dim Temp As String
    
    'Setup path
    Temp = Trim(iPath)
    
    If InStr(1, Temp, ":") = 2 Then
        'Local path
        Temp = Replace(Temp, "/", "\")
        If iCreate Then: Temp = CreatePath(Temp)
        
        'Ensure slashes
        Temp = Temp & IIf(Right(Temp, 1) = "\", "", "\")
        Temp = Replace(Temp, "\\", "\")
    
    ElseIf InStr(1, Temp, "\\") = 1 Then
        'Network path
        Temp = Replace(Temp, "\", "/")
        Temp = Replace(Temp, ":", "")
        
        'Ensure slashes
        Temp = Temp & IIf(Right(Temp, 1) = "/", "", "/")
        Temp = Replace(Temp, "\\", "\")
    End If
    
    'Return path
    GetPath = Temp
End Function

Public Function Exists(iFileName As String) As Boolean
    'Check filename
    Exists = (Len(Dir(iFileName, vbArchive Or vbHidden Or vbNormal Or vbReadOnly Or vbSystem)) > 0)
End Function

Public Sub Initialize()
    'Get paths
    Path = GetPath(App.Path)
    'NewPath = GetPath(Path & "New")
End Sub

Public Sub DeletePath(iPath As String)
On Error Resume Next

    Dim A As Integer
    Dim FileListCount As Integer
    Dim FileList() As String
    
    Dim Result As String
    
    'Pre-check
    If Len(iPath) < 4 Then: Exit Sub 'Allow at least C:\X
    
    'Setup vars
    FileListCount = -1
    iPath = iPath & IIf(Right(iPath, 1) = "\", "", "\")
    Result = Dir(iPath & "*.*", vbDirectory)
    
    'Get list
    While Len(Result) > 0
        If Not (Result = "." Or Result = "..") Then
            'Allocate memory
            FileListCount = FileListCount + 1
            ReDim Preserve FileList(FileListCount)
            
            'Set item
            FileList(FileListCount) = Result
        End If
        
        'Get next item
        Result = Dir
    Wend
    
    'Process folders
    For A = 0 To FileListCount
        If (GetAttr(iPath & FileList(A)) And vbDirectory) = vbDirectory Then
            'Delete sub-folder
            DeletePath iPath & FileList(A) & "\"
        Else
            'Delete file
            DeleteFile iPath & FileList(A)
        End If
    Next
    
    'Remove this folder
    RmDir iPath
End Sub

